//	author:	Barnabas Aszodi (BME-IIT)

#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "ManagedOgreRenderTexturePass.h"
#include "CAURenderRefractObjectMapPass.h"


CAURenderRefractObjectMapPass::CAURenderRefractObjectMapPass(
			Root* mRoot):ManagedOgreRenderTexturePass(mRoot,"NO_RENDER_TEXTURE",1,1)
{
	effectWrapper->createMaterial("RenderRefractObj");
}

void CAURenderRefractObjectMapPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
	effectWrapper->SetVertexProgramParameters();
	effectWrapper->SetMatrix("g_mWorldViewProj",g_mWorldViewProj);
	effectWrapper->SetMatrix("g_mWorldEntityMesh",g_mWorldEntityMesh);
	effectWrapper->SetVector3("g_vCameraPos3f",g_vCameraPos3f);
	effectWrapper->SetFragmentProgramParameters();
	effectWrapper->SetFloat("g_fFovCamera", g_fFovCamera);
}


void CAURenderRefractObjectMapPass::onRenderEnd(NameValuePairList* namedParams)
{
	effectWrapper->EndPass();
}

Matrix4 CAURenderRefractObjectMapPass::getWorldEntityMesh()
{
	return g_mWorldEntityMesh;
}

void CAURenderRefractObjectMapPass::setWorldEntityMesh( Matrix4 matrix4 )
{
	g_mWorldEntityMesh = matrix4;
}

Matrix4 CAURenderRefractObjectMapPass::getWorldViewProj()
{
	return g_mWorldViewProj;
}

void CAURenderRefractObjectMapPass::setWorldViewProj( Matrix4 matrix4 )
{
	g_mWorldViewProj = matrix4;
}

Vector3 CAURenderRefractObjectMapPass::getCameraPos3f()
{
	return g_vCameraPos3f;
}

void CAURenderRefractObjectMapPass::setCameraPos3f( Vector3 v )
{
	g_vCameraPos3f = v;
}

float CAURenderRefractObjectMapPass::getFovCamera()
{
	return g_fFovCamera;
}

void CAURenderRefractObjectMapPass::setFovCamera( float f )
{
	g_fFovCamera = f;
}
