#ifndef __GEO_SERIALIZABLE_H__
#define __GEO_SERIALIZABLE_H__

#include "GeoSerializer.h"

namespace Geometry {

	/// Serializable interface
	/** Base class of objects to simplify input/output. */
	class Serializable
	{
	public:

		/// Copy constructor
		//Serializable(const Serializable&);

		/// Assignment operator
		//Serializable& operator =(const Serializable&);

		/// Loads data from a Serializer.
		virtual void Load(Serializer &s) = 0;

		/// Saves data to a Serializer.
		virtual void Save(Serializer &s) = 0;
	};
}

#endif